| Disk ARchive 2.8.1 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::trontextual Class Reference
Private

trontextual class is a contextual class tronc, that's all. More...

`#include <trontextual.hpp>`

Inherits libdar::tronc, and libdar::contextual.

## Public Member Functions
| trontextual (generic_file *f, const infinint &offset, const infinint &size, bool own_f=false)
| trontextual (generic_file *f, const infinint &offset, const infinint &size, gf_mode mode, bool own_f=false)
| trontextual (const trontextual &ref)=delete
| trontextual (trontextual &&ref) noexcept=delete
trontextual & | operator= (const trontextual &ref)=delete
trontextual & | operator= (trontextual &&ref)=delete
virtual bool | is_an_old_start_end_archive () const override
| returns whether the archive is a old archive (format < 8)
virtual const label & | get_data_name () const override
| obtain the data_name of the archive (label associated with the archive's data)
Public Member Functions inherited from libdar::tronc
| tronc (generic_file *f, const infinint &offset, const infinint &size, bool own_f=false)
| constructor
| tronc (generic_file *f, const infinint &offset, const infinint &size, gf_mode mode, bool own_f=false)
| tronc (generic_file *f, const infinint &offset, bool own_f=false)
| tronc (generic_file *f, const infinint &offset, gf_mode mode, bool own_f=false)
| tronc (const tronc &ref)=delete
| tronc (tronc &&ref) noexcept=delete
tronc & | operator= (const tronc &ref)=delete
tronc & | operator= (tronc &&ref)=delete
| ~tronc ()
| destructor
void | modify (const infinint &new_offset, const infinint &new_size)
| modify the tronc object to zoom on another (size limited) portion of the underlying object
void | modify (const infinint &new_offset)
| modify the tronc object to zoom on another (size unlimited) portion of the underlying object
void | modify ()
| modify the tronc object to become transparent and allow unrestricted access to the underlyuing object
virtual bool | skippable (skippability direction, const infinint &amount) override
| inherited from generic_file
virtual bool | skip (const infinint &pos) override
| inherited from generic_file
virtual bool | skip_to_eof () override
| inherited from generic_file
virtual bool | skip_relative (S_I x) override
| inherited from generic_file
virtual bool | truncatable (const infinint &pos) const override
| inherited from generic_file
virtual infinint | get_position () const override
| get the current read/write position
void | check_underlying_position_while_reading_or_writing (bool mode)
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor
Public Member Functions inherited from libdar::contextual
| contextual (const contextual &ref)=default
| contextual (contextual &&ref) noexcept=default
contextual & | operator= (const contextual &ref)=default
contextual & | operator= (contextual &&ref) noexcept=default
virtual void | set_info_status (const std::string &s)
| defines the new contextual value
virtual std::string | get_info_status () const
| get the current contextual value

## Private Member Functions
void | init (generic_file *f)

## Private Attributes
contextual * | ref
| this is just a pointer to data owned by the inherited class tronc part of this object

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward }
Protected Member Functions inherited from libdar::tronc
virtual void | inherited_read_ahead (const infinint &amount) override
| inherited from generic_file
virtual U_I | inherited_read (char *a, U_I size) override
| inherited from generic_file
virtual void | inherited_write (const char *a, U_I size) override
| inherited from generic_file
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset
virtual void | inherited_sync_write () override
| write down any pending data
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const

## Detailed Description

trontextual class is a contextual class tronc, that's all.

Definition at line 44 of file trontextual.hpp.

## Member Function Documentation

## ◆ get_data_name()

virtual const label & libdar::trontextual::get_data_name | ( |  | ) | const
| inlineoverridevirtual

obtain the data_name of the archive (label associated with the archive's data)

Note
  label are conserved with dar_xform and archive isolation, but are not with archive merging or archive creation (full or differential backup)

Implements libdar::contextual.

Definition at line 56 of file trontextual.hpp.

References libdar::contextual::get_data_name(), and ref.

## ◆ is_an_old_start_end_archive()

virtual bool libdar::trontextual::is_an_old_start_end_archive | ( |  | ) | const
| inlineoverridevirtual

returns whether the archive is a old archive (format < 8)

Implements libdar::contextual.

Definition at line 55 of file trontextual.hpp.

References libdar::contextual::is_an_old_start_end_archive(), and ref.

## Member Data Documentation

## ◆ ref

contextual* libdar::trontextual::ref
| private

this is just a pointer to data owned by the inherited class tronc part of this object

Definition at line 59 of file trontextual.hpp.

Referenced by get_data_name(), and is_an_old_start_end_archive().

The documentation for this class was generated from the following file:

- trontextual.hpp